/**
 * @file Tickformatstop.h
This attribute is part of the possible options for the trace carpet.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#carpet>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>




namespace CppPlotly {
    namespace Trace {
    namespace carpet {
namespace aaxis {

    /**
     * 
     *
     *
     */
    class Tickformatstop {
    public:

    /**
range [*min*, *max*], where *min*, *max* - dtick values which describe some zoom level, it is possible to omit *min* or *max* value by passing *null*
*/Tickformatstop & Dtickrange(const std::vector<std::string> &dtickrange ) {
    _tickformatstop.insert({"dtickrange", dtickrange});
    return *this;
}


/**
Determines whether or not this stop is used. If `false`, this stop is ignored even within its `dtickrange`.
*/Tickformatstop & Enabled(const bool &enabled ) {
    _tickformatstop.insert({"enabled", enabled});
    return *this;
}


/**
When used in a template, named items are created in the output figure in addition to any items the figure already has in this array. You can modify these items in the output figure by making your own item with `templateitemname` matching this `name` alongside your modifications (including `visible: false` or `enabled: false` to hide it). Has no effect outside of a template.
*/Tickformatstop & Name(const std::string &name ) {
    _tickformatstop.insert({"name", name});
    return *this;
}


/**
Used to refer to a named item in this array in the template. Named items from the template will be created even without a matching item in the input figure, but you can modify one by making an item with `templateitemname` matching its `name`, alongside your modifications (including `visible: false` or `enabled: false` to hide it). If there is no template or no matching item, this item will be hidden unless you explicitly show it with `visible: true`.
*/Tickformatstop & Templateitemname(const std::string &templateitemname ) {
    _tickformatstop.insert({"templateitemname", templateitemname});
    return *this;
}


/**
string - dtickformat for described zoom level, the same as *tickformat*
*/Tickformatstop & Value(const std::string &value ) {
    _tickformatstop.insert({"value", value});
    return *this;
}




    json11::Json to_json() const {
        return _tickformatstop;
    }

    private:

    json11::Json::object _tickformatstop;

    };

    }
}

    }
}
