/**
 * @file Title.h
This attribute is part of the possible options for the trace carpet.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#carpet>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>

#include "CppPlotly/Trace/Carpet/Aaxis/Title/Font.h"



namespace CppPlotly {
    namespace Trace {
    namespace carpet {
namespace aaxis {

    /**
     * 
     *
     *
     */
    class Title {
    public:

    Title & Font(const CppPlotly::Trace::carpet::aaxis::title::Font &font ) {
    _title.insert({"font", font});
    return *this;
}


/**
An additional amount by which to offset the title from the tick labels, given in pixels. Note that this used to be set by the now deprecated `titleoffset` attribute.
*/Title & Offset(const double &offset ) {
    _title.insert({"offset", offset});
    return *this;
}


/**
Sets the title of this axis. Note that before the existence of `title.text`, the title's contents used to be defined as the `title` attribute itself. This behavior has been deprecated.
*/Title & Text(const std::string &text ) {
    _title.insert({"text", text});
    return *this;
}




    json11::Json to_json() const {
        return _title;
    }

    private:

    json11::Json::object _title;

    };

    }
}

    }
}
