/**
 * @file Marker.h
This attribute is part of the possible options for the trace choropleth.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#choropleth>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>

#include "CppPlotly/Trace/Choropleth/Marker/Line.h"



namespace CppPlotly {
    namespace Trace {
    namespace choropleth {

    /**
     * 
     *
     *
     */
    class Marker {
    public:

    Marker & Line(const CppPlotly::Trace::choropleth::marker::Line &line ) {
    _marker.insert({"line", line});
    return *this;
}


/**
Sets the opacity of the locations.
*/Marker & Opacity(const json11::Json &opacity ) {
    _marker.insert({"opacity", opacity});
    return *this;
}


/**
Sets the source reference on plot.ly for  opacity .
*/Marker & Opacitysrc(const std::string &opacitysrc ) {
    _marker.insert({"opacitysrc", opacitysrc});
    return *this;
}




    json11::Json to_json() const {
        return _marker;
    }

    private:

    json11::Json::object _marker;

    };

    }

    }
}
