/**
 * @file Parcoords.h
This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#parcoords>

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.
 *
 */
#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>

#include "../BaseTrace.h"

#include "CppPlotly/Trace/Parcoords/Dimension.h"
#include "CppPlotly/Trace/Parcoords/Domain.h"
#include "CppPlotly/Trace/Parcoords/Labelfont.h"
#include "CppPlotly/Trace/Parcoords/Line.h"
#include "CppPlotly/Trace/Parcoords/Rangefont.h"
#include "CppPlotly/Trace/Parcoords/Stream.h"
#include "CppPlotly/Trace/Parcoords/Tickfont.h"
#include "CppPlotly/Trace/Parcoords/Transform.h"


namespace CppPlotly {
    namespace Trace {
        /**
         * Parallel coordinates for multidimensional exploratory data analysis. The samples are specified in `dimensions`. The colors are set in `line.color`.
         *
         *
         */ 
        class Parcoords : public virtual CppPlotly::BaseTrace {
        public:
            Parcoords() :
                            _parcoords({
                                {"type", "parcoords"},
                                    })
                        {}

           /**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Parcoords & Customdata(const std::vector<double> &customdata ) {
    _parcoords.insert({"customdata", customdata});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Parcoords & Customdata(const std::vector<std::string> &customdata ) {
    _parcoords.insert({"customdata", customdata});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Parcoords & Customdata(const json11::Json &customdata ) {
    _parcoords.insert({"customdata", customdata});
    return *this;
}


/**
Sets the source reference on plot.ly for  customdata .
*/Parcoords & Customdatasrc(const std::string &customdatasrc ) {
    _parcoords.insert({"customdatasrc", customdatasrc});
    return *this;
}


Parcoords & Dimensions(const std::vector<CppPlotly::Trace::parcoords::Dimension> &dimensions ) {
    _parcoords.insert({"dimensions", dimensions});
    return *this;
}


Parcoords & Domain(const CppPlotly::Trace::parcoords::Domain &domain ) {
    _parcoords.insert({"domain", domain});
    return *this;
}


/**
Determines which trace information appear on hover. If `none` or `skip` are set, no information is displayed upon hovering. But, if `none` is set, click and hover events are still fired.
*/Parcoords & Hoverinfo(const json11::Json &hoverinfo ) {
    _parcoords.insert({"hoverinfo", hoverinfo});
    return *this;
}


/**
Sets the source reference on plot.ly for  hoverinfo .
*/Parcoords & Hoverinfosrc(const std::string &hoverinfosrc ) {
    _parcoords.insert({"hoverinfosrc", hoverinfosrc});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Parcoords & Ids(const std::vector<double> &ids ) {
    _parcoords.insert({"ids", ids});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Parcoords & Ids(const std::vector<std::string> &ids ) {
    _parcoords.insert({"ids", ids});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Parcoords & Ids(const json11::Json &ids ) {
    _parcoords.insert({"ids", ids});
    return *this;
}


/**
Sets the source reference on plot.ly for  ids .
*/Parcoords & Idssrc(const std::string &idssrc ) {
    _parcoords.insert({"idssrc", idssrc});
    return *this;
}


Parcoords & Labelfont(const CppPlotly::Trace::parcoords::Labelfont &labelfont ) {
    _parcoords.insert({"labelfont", labelfont});
    return *this;
}


/**
Sets the legend group for this trace. Traces part of the same legend group hide/show at the same time when toggling legend items.
*/Parcoords & Legendgroup(const std::string &legendgroup ) {
    _parcoords.insert({"legendgroup", legendgroup});
    return *this;
}


Parcoords & Line(const CppPlotly::Trace::parcoords::Line &line ) {
    _parcoords.insert({"line", line});
    return *this;
}


/**
Sets the trace name. The trace name appear as the legend item and on hover.
*/Parcoords & Name(const std::string &name ) {
    _parcoords.insert({"name", name});
    return *this;
}


/**
Sets the opacity of the trace.
*/Parcoords & Opacity(const double &opacity ) {
    _parcoords.insert({"opacity", opacity});
    return *this;
}


Parcoords & Rangefont(const CppPlotly::Trace::parcoords::Rangefont &rangefont ) {
    _parcoords.insert({"rangefont", rangefont});
    return *this;
}


/**
Array containing integer indices of selected points. Has an effect only for traces that support selections. Note that an empty array means an empty selection where the `unselected` are turned on for all points, whereas, any other non-array values means no selection all where the `selected` and `unselected` styles have no effect.
*/Parcoords & Selectedpoints(const json11::Json &selectedpoints ) {
    _parcoords.insert({"selectedpoints", selectedpoints});
    return *this;
}


/**
Determines whether or not an item corresponding to this trace is shown in the legend.
*/Parcoords & Showlegend(const bool &showlegend ) {
    _parcoords.insert({"showlegend", showlegend});
    return *this;
}


Parcoords & Stream(const CppPlotly::Trace::parcoords::Stream &stream ) {
    _parcoords.insert({"stream", stream});
    return *this;
}


Parcoords & Tickfont(const CppPlotly::Trace::parcoords::Tickfont &tickfont ) {
    _parcoords.insert({"tickfont", tickfont});
    return *this;
}


Parcoords & Transforms(const std::vector<CppPlotly::Trace::parcoords::Transform> &transforms ) {
    _parcoords.insert({"transforms", transforms});
    return *this;
}


/**
Assign an id to this trace, Use this to provide object constancy between traces during animations and transitions.
*/Parcoords & Uid(const std::string &uid ) {
    _parcoords.insert({"uid", uid});
    return *this;
}


/**
Controls persistence of some user-driven changes to the trace: `constraintrange` in `parcoords` traces, as well as some `editable: true` modifications such as `name` and `colorbar.title`. Defaults to `layout.uirevision`. Note that other user-driven trace attribute changes are controlled by `layout` attributes: `trace.visible` is controlled by `layout.legend.uirevision`, `selectedpoints` is controlled by `layout.selectionrevision`, and `colorbar.(x|y)` (accessible with `config: {editable: true}`) is controlled by `layout.editrevision`. Trace changes are tracked by `uid`, which only falls back on trace index if no `uid` is provided. So if your app can add/remove traces before the end of the `data` array, such that the same trace has a different index, you can still preserve user-driven changes if you give each trace a `uid` that stays with it as it moves.
*/Parcoords & Uirevision(const json11::Json &uirevision ) {
    _parcoords.insert({"uirevision", uirevision});
    return *this;
}


/**
Determines whether or not this trace is visible. If *legendonly*, the trace is not drawn, but can appear as a legend item (provided that the legend itself is visible).
*/Parcoords & Visible(const json11::Json &visible ) {
    _parcoords.insert({"visible", visible});
    return *this;
}


 

            virtual json11::Json to_json() const {
                return _parcoords;
            }

        private:
            
            json11::Json::object _parcoords;

        };
    }
}


