/**
 * @file Border.h
This attribute is part of the possible options for the trace pointcloud.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#pointcloud>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>




namespace CppPlotly {
    namespace Trace {
    namespace pointcloud {
namespace marker {

    /**
     * 
     *
     *
     */
    class Border {
    public:

    /**
Specifies what fraction of the marker area is covered with the border.
*/Border & Arearatio(const double &arearatio ) {
    _border.insert({"arearatio", arearatio});
    return *this;
}


/**
Sets the stroke color. It accepts a specific color. If the color is not fully opaque and there are hundreds of thousands of points, it may cause slower zooming and panning.
*/Border & Color(const json11::Json &color ) {
    _border.insert({"color", color});
    return *this;
}




    json11::Json to_json() const {
        return _border;
    }

    private:

    json11::Json::object _border;

    };

    }
}

    }
}
