/**
 * @file Gradient.h
This attribute is part of the possible options for the trace scatter.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#scatter>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>




namespace CppPlotly {
    namespace Trace {
    namespace scatter {
namespace marker {

    /**
     * 
     *
     *
     */
    class Gradient {
    public:

    /**
Sets the final color of the gradient fill: the center color for radial, the right for horizontal, or the bottom for vertical.
*/Gradient & Color(const json11::Json &color ) {
    _gradient.insert({"color", color});
    return *this;
}


/**
Sets the source reference on plot.ly for  color .
*/Gradient & Colorsrc(const std::string &colorsrc ) {
    _gradient.insert({"colorsrc", colorsrc});
    return *this;
}


/**
Sets the source reference on plot.ly for  type .
*/Gradient & Typesrc(const std::string &typesrc ) {
    _gradient.insert({"typesrc", typesrc});
    return *this;
}




    json11::Json to_json() const {
        return _gradient;
    }

    private:

    json11::Json::object _gradient;

    };

    }
}

    }
}
