/**
 * @file Scatter3d.h
This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#scatter3d>

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.
 *
 */
#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>

#include "../BaseTrace.h"

#include "CppPlotly/Trace/Scatter3d/Error_x.h"
#include "CppPlotly/Trace/Scatter3d/Error_y.h"
#include "CppPlotly/Trace/Scatter3d/Error_z.h"
#include "CppPlotly/Trace/Scatter3d/Hoverlabel.h"
#include "CppPlotly/Trace/Scatter3d/Line.h"
#include "CppPlotly/Trace/Scatter3d/Marker.h"
#include "CppPlotly/Trace/Scatter3d/Projection.h"
#include "CppPlotly/Trace/Scatter3d/Stream.h"
#include "CppPlotly/Trace/Scatter3d/Textfont.h"
#include "CppPlotly/Trace/Scatter3d/Transform.h"


namespace CppPlotly {
    namespace Trace {
        /**
         * The data visualized as scatter point or lines in 3D dimension is set in `x`, `y`, `z`. Text (appearing either on the chart or on hover only) is via `text`. Bubble charts are achieved by setting `marker.size` and/or `marker.color` Projections are achieved via `projection`. Surface fills are achieved via `surfaceaxis`.
         *
         *
         */ 
        class Scatter3d : public virtual CppPlotly::BaseTrace {
        public:
            Scatter3d() :
                            _scatter3d({
                                {"type", "scatter3d"},
                                    })
                        {}

           /**
Determines whether or not gaps (i.e. {nan} or missing values) in the provided data arrays are connected.
*/Scatter3d & Connectgaps(const bool &connectgaps ) {
    _scatter3d.insert({"connectgaps", connectgaps});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Scatter3d & Customdata(const std::vector<double> &customdata ) {
    _scatter3d.insert({"customdata", customdata});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Scatter3d & Customdata(const std::vector<std::string> &customdata ) {
    _scatter3d.insert({"customdata", customdata});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Scatter3d & Customdata(const json11::Json &customdata ) {
    _scatter3d.insert({"customdata", customdata});
    return *this;
}


/**
Sets the source reference on plot.ly for  customdata .
*/Scatter3d & Customdatasrc(const std::string &customdatasrc ) {
    _scatter3d.insert({"customdatasrc", customdatasrc});
    return *this;
}


Scatter3d & Error_x(const CppPlotly::Trace::scatter3d::Error_x &error_x ) {
    _scatter3d.insert({"error_x", error_x});
    return *this;
}


Scatter3d & Error_y(const CppPlotly::Trace::scatter3d::Error_y &error_y ) {
    _scatter3d.insert({"error_y", error_y});
    return *this;
}


Scatter3d & Error_z(const CppPlotly::Trace::scatter3d::Error_z &error_z ) {
    _scatter3d.insert({"error_z", error_z});
    return *this;
}


/**
Determines which trace information appear on hover. If `none` or `skip` are set, no information is displayed upon hovering. But, if `none` is set, click and hover events are still fired.
*/Scatter3d & Hoverinfo(const json11::Json &hoverinfo ) {
    _scatter3d.insert({"hoverinfo", hoverinfo});
    return *this;
}


/**
Sets the source reference on plot.ly for  hoverinfo .
*/Scatter3d & Hoverinfosrc(const std::string &hoverinfosrc ) {
    _scatter3d.insert({"hoverinfosrc", hoverinfosrc});
    return *this;
}


Scatter3d & Hoverlabel(const CppPlotly::Trace::scatter3d::Hoverlabel &hoverlabel ) {
    _scatter3d.insert({"hoverlabel", hoverlabel});
    return *this;
}


/**
Template string used for rendering the information that appear on hover box. Note that this will override `hoverinfo`. Variables are inserted using %{variable}, for example "y: %{y}". Numbers are formatted using d3-format's syntax %{variable:d3-format}, for example "Price: %{y:$.2f}". See https://github.com/d3/d3-format/blob/master/README.md#locale_format for details on the formatting syntax. The variables available in `hovertemplate` are the ones emitted as event data described at this link https://plot.ly/javascript/plotlyjs-events/#event-data. Additionally, every attributes that can be specified per-point (the ones that are `arrayOk: true`) are available.  Anything contained in tag `<extra>` is displayed in the secondary box, for example "<extra>{fullData.name}</extra>". To hide the secondary box completely, use an empty tag `<extra></extra>`.
*/Scatter3d & Hovertemplate(const json11::Json &hovertemplate ) {
    _scatter3d.insert({"hovertemplate", hovertemplate});
    return *this;
}


/**
Sets the source reference on plot.ly for  hovertemplate .
*/Scatter3d & Hovertemplatesrc(const std::string &hovertemplatesrc ) {
    _scatter3d.insert({"hovertemplatesrc", hovertemplatesrc});
    return *this;
}


/**
Sets text elements associated with each (x,y,z) triplet. If a single string, the same string appears over all the data points. If an array of string, the items are mapped in order to the this trace's (x,y,z) coordinates. To be seen, trace `hoverinfo` must contain a *text* flag.
*/Scatter3d & Hovertext(const json11::Json &hovertext ) {
    _scatter3d.insert({"hovertext", hovertext});
    return *this;
}


/**
Sets the source reference on plot.ly for  hovertext .
*/Scatter3d & Hovertextsrc(const std::string &hovertextsrc ) {
    _scatter3d.insert({"hovertextsrc", hovertextsrc});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Scatter3d & Ids(const std::vector<double> &ids ) {
    _scatter3d.insert({"ids", ids});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Scatter3d & Ids(const std::vector<std::string> &ids ) {
    _scatter3d.insert({"ids", ids});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Scatter3d & Ids(const json11::Json &ids ) {
    _scatter3d.insert({"ids", ids});
    return *this;
}


/**
Sets the source reference on plot.ly for  ids .
*/Scatter3d & Idssrc(const std::string &idssrc ) {
    _scatter3d.insert({"idssrc", idssrc});
    return *this;
}


/**
Sets the legend group for this trace. Traces part of the same legend group hide/show at the same time when toggling legend items.
*/Scatter3d & Legendgroup(const std::string &legendgroup ) {
    _scatter3d.insert({"legendgroup", legendgroup});
    return *this;
}


Scatter3d & Line(const CppPlotly::Trace::scatter3d::Line &line ) {
    _scatter3d.insert({"line", line});
    return *this;
}


Scatter3d & Marker(const CppPlotly::Trace::scatter3d::Marker &marker ) {
    _scatter3d.insert({"marker", marker});
    return *this;
}


/**
Determines the drawing mode for this scatter trace. If the provided `mode` includes *text* then the `text` elements appear at the coordinates. Otherwise, the `text` elements appear on hover. If there are less than 20 points and the trace is not stacked then the default is *lines+markers*. Otherwise, *lines*.
*/Scatter3d & Mode(const json11::Json &mode ) {
    _scatter3d.insert({"mode", mode});
    return *this;
}


/**
Sets the trace name. The trace name appear as the legend item and on hover.
*/Scatter3d & Name(const std::string &name ) {
    _scatter3d.insert({"name", name});
    return *this;
}


/**
Sets the opacity of the trace.
*/Scatter3d & Opacity(const double &opacity ) {
    _scatter3d.insert({"opacity", opacity});
    return *this;
}


Scatter3d & Projection(const CppPlotly::Trace::scatter3d::Projection &projection ) {
    _scatter3d.insert({"projection", projection});
    return *this;
}


/**
Sets a reference between this trace's 3D coordinate system and a 3D scene. If *scene* (the default value), the (x,y,z) coordinates refer to `layout.scene`. If *scene2*, the (x,y,z) coordinates refer to `layout.scene2`, and so on.
*/Scatter3d & Scene(const json11::Json &scene ) {
    _scatter3d.insert({"scene", scene});
    return *this;
}


/**
Array containing integer indices of selected points. Has an effect only for traces that support selections. Note that an empty array means an empty selection where the `unselected` are turned on for all points, whereas, any other non-array values means no selection all where the `selected` and `unselected` styles have no effect.
*/Scatter3d & Selectedpoints(const json11::Json &selectedpoints ) {
    _scatter3d.insert({"selectedpoints", selectedpoints});
    return *this;
}


/**
Determines whether or not an item corresponding to this trace is shown in the legend.
*/Scatter3d & Showlegend(const bool &showlegend ) {
    _scatter3d.insert({"showlegend", showlegend});
    return *this;
}


Scatter3d & Stream(const CppPlotly::Trace::scatter3d::Stream &stream ) {
    _scatter3d.insert({"stream", stream});
    return *this;
}


/**
If *-1*, the scatter points are not fill with a surface If *0*, *1*, *2*, the scatter points are filled with a Delaunay surface about the x, y, z respectively.
*/Scatter3d & Surfaceaxis(const json11::Json &surfaceaxis ) {
    _scatter3d.insert({"surfaceaxis", surfaceaxis});
    return *this;
}


/**
Sets the surface fill color.
*/Scatter3d & Surfacecolor(const json11::Json &surfacecolor ) {
    _scatter3d.insert({"surfacecolor", surfacecolor});
    return *this;
}


/**
Sets text elements associated with each (x,y,z) triplet. If a single string, the same string appears over all the data points. If an array of string, the items are mapped in order to the this trace's (x,y,z) coordinates. If trace `hoverinfo` contains a *text* flag and *hovertext* is not set, these elements will be seen in the hover labels.
*/Scatter3d & Text(const json11::Json &text ) {
    _scatter3d.insert({"text", text});
    return *this;
}


Scatter3d & Textfont(const CppPlotly::Trace::scatter3d::Textfont &textfont ) {
    _scatter3d.insert({"textfont", textfont});
    return *this;
}


/**
Sets the positions of the `text` elements with respects to the (x,y) coordinates.
*/Scatter3d & Textposition(const json11::Json &textposition ) {
    _scatter3d.insert({"textposition", textposition});
    return *this;
}


/**
Sets the source reference on plot.ly for  textposition .
*/Scatter3d & Textpositionsrc(const std::string &textpositionsrc ) {
    _scatter3d.insert({"textpositionsrc", textpositionsrc});
    return *this;
}


/**
Sets the source reference on plot.ly for  text .
*/Scatter3d & Textsrc(const std::string &textsrc ) {
    _scatter3d.insert({"textsrc", textsrc});
    return *this;
}


Scatter3d & Transforms(const std::vector<CppPlotly::Trace::scatter3d::Transform> &transforms ) {
    _scatter3d.insert({"transforms", transforms});
    return *this;
}


/**
Assign an id to this trace, Use this to provide object constancy between traces during animations and transitions.
*/Scatter3d & Uid(const std::string &uid ) {
    _scatter3d.insert({"uid", uid});
    return *this;
}


/**
Controls persistence of some user-driven changes to the trace: `constraintrange` in `parcoords` traces, as well as some `editable: true` modifications such as `name` and `colorbar.title`. Defaults to `layout.uirevision`. Note that other user-driven trace attribute changes are controlled by `layout` attributes: `trace.visible` is controlled by `layout.legend.uirevision`, `selectedpoints` is controlled by `layout.selectionrevision`, and `colorbar.(x|y)` (accessible with `config: {editable: true}`) is controlled by `layout.editrevision`. Trace changes are tracked by `uid`, which only falls back on trace index if no `uid` is provided. So if your app can add/remove traces before the end of the `data` array, such that the same trace has a different index, you can still preserve user-driven changes if you give each trace a `uid` that stays with it as it moves.
*/Scatter3d & Uirevision(const json11::Json &uirevision ) {
    _scatter3d.insert({"uirevision", uirevision});
    return *this;
}


/**
Determines whether or not this trace is visible. If *legendonly*, the trace is not drawn, but can appear as a legend item (provided that the legend itself is visible).
*/Scatter3d & Visible(const json11::Json &visible ) {
    _scatter3d.insert({"visible", visible});
    return *this;
}


/**
Sets the x coordinates.
*/Scatter3d & X(const std::vector<double> &x ) {
    _scatter3d.insert({"x", x});
    return *this;
}


/**
Sets the x coordinates.
*/Scatter3d & X(const std::vector<std::string> &x ) {
    _scatter3d.insert({"x", x});
    return *this;
}


/**
Sets the x coordinates.
*/Scatter3d & X(const json11::Json &x ) {
    _scatter3d.insert({"x", x});
    return *this;
}


/**
Sets the calendar system to use with `x` date data.
*/Scatter3d & Xcalendar(const json11::Json &xcalendar ) {
    _scatter3d.insert({"xcalendar", xcalendar});
    return *this;
}


/**
Sets the source reference on plot.ly for  x .
*/Scatter3d & Xsrc(const std::string &xsrc ) {
    _scatter3d.insert({"xsrc", xsrc});
    return *this;
}


/**
Sets the y coordinates.
*/Scatter3d & Y(const std::vector<double> &y ) {
    _scatter3d.insert({"y", y});
    return *this;
}


/**
Sets the y coordinates.
*/Scatter3d & Y(const std::vector<std::string> &y ) {
    _scatter3d.insert({"y", y});
    return *this;
}


/**
Sets the y coordinates.
*/Scatter3d & Y(const json11::Json &y ) {
    _scatter3d.insert({"y", y});
    return *this;
}


/**
Sets the calendar system to use with `y` date data.
*/Scatter3d & Ycalendar(const json11::Json &ycalendar ) {
    _scatter3d.insert({"ycalendar", ycalendar});
    return *this;
}


/**
Sets the source reference on plot.ly for  y .
*/Scatter3d & Ysrc(const std::string &ysrc ) {
    _scatter3d.insert({"ysrc", ysrc});
    return *this;
}


/**
Sets the z coordinates.
*/Scatter3d & Z(const std::vector<double> &z ) {
    _scatter3d.insert({"z", z});
    return *this;
}


/**
Sets the z coordinates.
*/Scatter3d & Z(const std::vector<std::string> &z ) {
    _scatter3d.insert({"z", z});
    return *this;
}


/**
Sets the z coordinates.
*/Scatter3d & Z(const json11::Json &z ) {
    _scatter3d.insert({"z", z});
    return *this;
}


/**
Sets the calendar system to use with `z` date data.
*/Scatter3d & Zcalendar(const json11::Json &zcalendar ) {
    _scatter3d.insert({"zcalendar", zcalendar});
    return *this;
}


/**
Sets the source reference on plot.ly for  z .
*/Scatter3d & Zsrc(const std::string &zsrc ) {
    _scatter3d.insert({"zsrc", zsrc});
    return *this;
}


 

            virtual json11::Json to_json() const {
                return _scatter3d;
            }

        private:
            
            json11::Json::object _scatter3d;

        };
    }
}


