/**
 * @file Projection.h
This attribute is part of the possible options for the trace scatter3d.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#scatter3d>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>

#include "CppPlotly/Trace/Scatter3d/Projection/X.h"
#include "CppPlotly/Trace/Scatter3d/Projection/Y.h"
#include "CppPlotly/Trace/Scatter3d/Projection/Z.h"



namespace CppPlotly {
    namespace Trace {
    namespace scatter3d {

    /**
     * 
     *
     *
     */
    class Projection {
    public:

    Projection & X(const CppPlotly::Trace::scatter3d::projection::X &x ) {
    _projection.insert({"x", x});
    return *this;
}


Projection & Y(const CppPlotly::Trace::scatter3d::projection::Y &y ) {
    _projection.insert({"y", y});
    return *this;
}


Projection & Z(const CppPlotly::Trace::scatter3d::projection::Z &z ) {
    _projection.insert({"z", z});
    return *this;
}




    json11::Json to_json() const {
        return _projection;
    }

    private:

    json11::Json::object _projection;

    };

    }

    }
}
