/**
 * @file X.h
This attribute is part of the possible options for the trace scatter3d.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#scatter3d>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>




namespace CppPlotly {
    namespace Trace {
    namespace scatter3d {
namespace projection {

    /**
     * 
     *
     *
     */
    class X {
    public:

    /**
Sets the projection color.
*/X & Opacity(const double &opacity ) {
    _x.insert({"opacity", opacity});
    return *this;
}


/**
Sets the scale factor determining the size of the projection marker points.
*/X & Scale(const double &scale ) {
    _x.insert({"scale", scale});
    return *this;
}


/**
Sets whether or not projections are shown along the x axis.
*/X & Show(const bool &show ) {
    _x.insert({"show", show});
    return *this;
}




    json11::Json to_json() const {
        return _x;
    }

    private:

    json11::Json::object _x;

    };

    }
}

    }
}
