/**
 * @file Scatterpolar.h
This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#scatterpolar>

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.
 *
 */
#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>

#include "../BaseTrace.h"

#include "CppPlotly/Trace/Scatterpolar/Hoverlabel.h"
#include "CppPlotly/Trace/Scatterpolar/Line.h"
#include "CppPlotly/Trace/Scatterpolar/Marker.h"
#include "CppPlotly/Trace/Scatterpolar/Selected.h"
#include "CppPlotly/Trace/Scatterpolar/Stream.h"
#include "CppPlotly/Trace/Scatterpolar/Textfont.h"
#include "CppPlotly/Trace/Scatterpolar/Transform.h"
#include "CppPlotly/Trace/Scatterpolar/Unselected.h"


namespace CppPlotly {
    namespace Trace {
        /**
         * The scatterpolar trace type encompasses line charts, scatter charts, text charts, and bubble charts in polar coordinates. The data visualized as scatter point or lines is set in `r` (radial) and `theta` (angular) coordinates Text (appearing either on the chart or on hover only) is via `text`. Bubble charts are achieved by setting `marker.size` and/or `marker.color` to numerical arrays.
         *
         *
         */ 
        class Scatterpolar : public virtual CppPlotly::BaseTrace {
        public:
            Scatterpolar() :
                            _scatterpolar({
                                {"type", "scatterpolar"},
                                    })
                        {}

           /**
Determines whether or not markers and text nodes are clipped about the subplot axes. To show markers and text nodes above axis lines and tick labels, make sure to set `xaxis.layer` and `yaxis.layer` to *below traces*.
*/Scatterpolar & Cliponaxis(const bool &cliponaxis ) {
    _scatterpolar.insert({"cliponaxis", cliponaxis});
    return *this;
}


/**
Determines whether or not gaps (i.e. {nan} or missing values) in the provided data arrays are connected.
*/Scatterpolar & Connectgaps(const bool &connectgaps ) {
    _scatterpolar.insert({"connectgaps", connectgaps});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Scatterpolar & Customdata(const std::vector<double> &customdata ) {
    _scatterpolar.insert({"customdata", customdata});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Scatterpolar & Customdata(const std::vector<std::string> &customdata ) {
    _scatterpolar.insert({"customdata", customdata});
    return *this;
}


/**
Assigns extra data each datum. This may be useful when listening to hover, click and selection events. Note that, *scatter* traces also appends customdata items in the markers DOM elements
*/Scatterpolar & Customdata(const json11::Json &customdata ) {
    _scatterpolar.insert({"customdata", customdata});
    return *this;
}


/**
Sets the source reference on plot.ly for  customdata .
*/Scatterpolar & Customdatasrc(const std::string &customdatasrc ) {
    _scatterpolar.insert({"customdatasrc", customdatasrc});
    return *this;
}


/**
Sets the r coordinate step.
*/Scatterpolar & Dr(const double &dr ) {
    _scatterpolar.insert({"dr", dr});
    return *this;
}


/**
Sets the theta coordinate step. By default, the `dtheta` step equals the subplot's period divided by the length of the `r` coordinates.
*/Scatterpolar & Dtheta(const double &dtheta ) {
    _scatterpolar.insert({"dtheta", dtheta});
    return *this;
}


/**
Sets the area to fill with a solid color. Use with `fillcolor` if not *none*. scatterpolar has a subset of the options available to scatter. *toself* connects the endpoints of the trace (or each segment of the trace if it has gaps) into a closed shape. *tonext* fills the space between two traces if one completely encloses the other (eg consecutive contour lines), and behaves like *toself* if there is no trace before it. *tonext* should not be used if one trace does not enclose the other.
*/Scatterpolar & Fill(const json11::Json &fill ) {
    _scatterpolar.insert({"fill", fill});
    return *this;
}


/**
Sets the fill color. Defaults to a half-transparent variant of the line color, marker color, or marker line color, whichever is available.
*/Scatterpolar & Fillcolor(const json11::Json &fillcolor ) {
    _scatterpolar.insert({"fillcolor", fillcolor});
    return *this;
}


/**
Determines which trace information appear on hover. If `none` or `skip` are set, no information is displayed upon hovering. But, if `none` is set, click and hover events are still fired.
*/Scatterpolar & Hoverinfo(const json11::Json &hoverinfo ) {
    _scatterpolar.insert({"hoverinfo", hoverinfo});
    return *this;
}


/**
Sets the source reference on plot.ly for  hoverinfo .
*/Scatterpolar & Hoverinfosrc(const std::string &hoverinfosrc ) {
    _scatterpolar.insert({"hoverinfosrc", hoverinfosrc});
    return *this;
}


Scatterpolar & Hoverlabel(const CppPlotly::Trace::scatterpolar::Hoverlabel &hoverlabel ) {
    _scatterpolar.insert({"hoverlabel", hoverlabel});
    return *this;
}


/**
Do the hover effects highlight individual points (markers or line points) or do they highlight filled regions? If the fill is *toself* or *tonext* and there are no markers or text, then the default is *fills*, otherwise it is *points*.
*/Scatterpolar & Hoveron(const json11::Json &hoveron ) {
    _scatterpolar.insert({"hoveron", hoveron});
    return *this;
}


/**
Template string used for rendering the information that appear on hover box. Note that this will override `hoverinfo`. Variables are inserted using %{variable}, for example "y: %{y}". Numbers are formatted using d3-format's syntax %{variable:d3-format}, for example "Price: %{y:$.2f}". See https://github.com/d3/d3-format/blob/master/README.md#locale_format for details on the formatting syntax. The variables available in `hovertemplate` are the ones emitted as event data described at this link https://plot.ly/javascript/plotlyjs-events/#event-data. Additionally, every attributes that can be specified per-point (the ones that are `arrayOk: true`) are available.  Anything contained in tag `<extra>` is displayed in the secondary box, for example "<extra>{fullData.name}</extra>". To hide the secondary box completely, use an empty tag `<extra></extra>`.
*/Scatterpolar & Hovertemplate(const json11::Json &hovertemplate ) {
    _scatterpolar.insert({"hovertemplate", hovertemplate});
    return *this;
}


/**
Sets the source reference on plot.ly for  hovertemplate .
*/Scatterpolar & Hovertemplatesrc(const std::string &hovertemplatesrc ) {
    _scatterpolar.insert({"hovertemplatesrc", hovertemplatesrc});
    return *this;
}


/**
Sets hover text elements associated with each (x,y) pair. If a single string, the same string appears over all the data points. If an array of string, the items are mapped in order to the this trace's (x,y) coordinates. To be seen, trace `hoverinfo` must contain a *text* flag.
*/Scatterpolar & Hovertext(const json11::Json &hovertext ) {
    _scatterpolar.insert({"hovertext", hovertext});
    return *this;
}


/**
Sets the source reference on plot.ly for  hovertext .
*/Scatterpolar & Hovertextsrc(const std::string &hovertextsrc ) {
    _scatterpolar.insert({"hovertextsrc", hovertextsrc});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Scatterpolar & Ids(const std::vector<double> &ids ) {
    _scatterpolar.insert({"ids", ids});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Scatterpolar & Ids(const std::vector<std::string> &ids ) {
    _scatterpolar.insert({"ids", ids});
    return *this;
}


/**
Assigns id labels to each datum. These ids for object constancy of data points during animation. Should be an array of strings, not numbers or any other type.
*/Scatterpolar & Ids(const json11::Json &ids ) {
    _scatterpolar.insert({"ids", ids});
    return *this;
}


/**
Sets the source reference on plot.ly for  ids .
*/Scatterpolar & Idssrc(const std::string &idssrc ) {
    _scatterpolar.insert({"idssrc", idssrc});
    return *this;
}


/**
Sets the legend group for this trace. Traces part of the same legend group hide/show at the same time when toggling legend items.
*/Scatterpolar & Legendgroup(const std::string &legendgroup ) {
    _scatterpolar.insert({"legendgroup", legendgroup});
    return *this;
}


Scatterpolar & Line(const CppPlotly::Trace::scatterpolar::Line &line ) {
    _scatterpolar.insert({"line", line});
    return *this;
}


Scatterpolar & Marker(const CppPlotly::Trace::scatterpolar::Marker &marker ) {
    _scatterpolar.insert({"marker", marker});
    return *this;
}


/**
Determines the drawing mode for this scatter trace. If the provided `mode` includes *text* then the `text` elements appear at the coordinates. Otherwise, the `text` elements appear on hover. If there are less than 20 points and the trace is not stacked then the default is *lines+markers*. Otherwise, *lines*.
*/Scatterpolar & Mode(const json11::Json &mode ) {
    _scatterpolar.insert({"mode", mode});
    return *this;
}


/**
Sets the trace name. The trace name appear as the legend item and on hover.
*/Scatterpolar & Name(const std::string &name ) {
    _scatterpolar.insert({"name", name});
    return *this;
}


/**
Sets the opacity of the trace.
*/Scatterpolar & Opacity(const double &opacity ) {
    _scatterpolar.insert({"opacity", opacity});
    return *this;
}


/**
Sets the radial coordinates
*/Scatterpolar & R(const std::vector<double> &r ) {
    _scatterpolar.insert({"r", r});
    return *this;
}


/**
Sets the radial coordinates
*/Scatterpolar & R(const std::vector<std::string> &r ) {
    _scatterpolar.insert({"r", r});
    return *this;
}


/**
Sets the radial coordinates
*/Scatterpolar & R(const json11::Json &r ) {
    _scatterpolar.insert({"r", r});
    return *this;
}


/**
Alternate to `r`. Builds a linear space of r coordinates. Use with `dr` where `r0` is the starting coordinate and `dr` the step.
*/Scatterpolar & R0(const json11::Json &r0 ) {
    _scatterpolar.insert({"r0", r0});
    return *this;
}


/**
Sets the source reference on plot.ly for  r .
*/Scatterpolar & Rsrc(const std::string &rsrc ) {
    _scatterpolar.insert({"rsrc", rsrc});
    return *this;
}


Scatterpolar & Selected(const CppPlotly::Trace::scatterpolar::Selected &selected ) {
    _scatterpolar.insert({"selected", selected});
    return *this;
}


/**
Array containing integer indices of selected points. Has an effect only for traces that support selections. Note that an empty array means an empty selection where the `unselected` are turned on for all points, whereas, any other non-array values means no selection all where the `selected` and `unselected` styles have no effect.
*/Scatterpolar & Selectedpoints(const json11::Json &selectedpoints ) {
    _scatterpolar.insert({"selectedpoints", selectedpoints});
    return *this;
}


/**
Determines whether or not an item corresponding to this trace is shown in the legend.
*/Scatterpolar & Showlegend(const bool &showlegend ) {
    _scatterpolar.insert({"showlegend", showlegend});
    return *this;
}


Scatterpolar & Stream(const CppPlotly::Trace::scatterpolar::Stream &stream ) {
    _scatterpolar.insert({"stream", stream});
    return *this;
}


/**
Sets a reference between this trace's data coordinates and a polar subplot. If *polar* (the default value), the data refer to `layout.polar`. If *polar2*, the data refer to `layout.polar2`, and so on.
*/Scatterpolar & Subplot(const json11::Json &subplot ) {
    _scatterpolar.insert({"subplot", subplot});
    return *this;
}


/**
Sets text elements associated with each (x,y) pair. If a single string, the same string appears over all the data points. If an array of string, the items are mapped in order to the this trace's (x,y) coordinates. If trace `hoverinfo` contains a *text* flag and *hovertext* is not set, these elements will be seen in the hover labels.
*/Scatterpolar & Text(const json11::Json &text ) {
    _scatterpolar.insert({"text", text});
    return *this;
}


Scatterpolar & Textfont(const CppPlotly::Trace::scatterpolar::Textfont &textfont ) {
    _scatterpolar.insert({"textfont", textfont});
    return *this;
}


/**
Sets the positions of the `text` elements with respects to the (x,y) coordinates.
*/Scatterpolar & Textposition(const json11::Json &textposition ) {
    _scatterpolar.insert({"textposition", textposition});
    return *this;
}


/**
Sets the source reference on plot.ly for  textposition .
*/Scatterpolar & Textpositionsrc(const std::string &textpositionsrc ) {
    _scatterpolar.insert({"textpositionsrc", textpositionsrc});
    return *this;
}


/**
Sets the source reference on plot.ly for  text .
*/Scatterpolar & Textsrc(const std::string &textsrc ) {
    _scatterpolar.insert({"textsrc", textsrc});
    return *this;
}


/**
Sets the angular coordinates
*/Scatterpolar & Theta(const std::vector<double> &theta ) {
    _scatterpolar.insert({"theta", theta});
    return *this;
}


/**
Sets the angular coordinates
*/Scatterpolar & Theta(const std::vector<std::string> &theta ) {
    _scatterpolar.insert({"theta", theta});
    return *this;
}


/**
Sets the angular coordinates
*/Scatterpolar & Theta(const json11::Json &theta ) {
    _scatterpolar.insert({"theta", theta});
    return *this;
}


/**
Alternate to `theta`. Builds a linear space of theta coordinates. Use with `dtheta` where `theta0` is the starting coordinate and `dtheta` the step.
*/Scatterpolar & Theta0(const json11::Json &theta0 ) {
    _scatterpolar.insert({"theta0", theta0});
    return *this;
}


/**
Sets the source reference on plot.ly for  theta .
*/Scatterpolar & Thetasrc(const std::string &thetasrc ) {
    _scatterpolar.insert({"thetasrc", thetasrc});
    return *this;
}


/**
Sets the unit of input *theta* values. Has an effect only when on *linear* angular axes.
*/Scatterpolar & Thetaunit(const json11::Json &thetaunit ) {
    _scatterpolar.insert({"thetaunit", thetaunit});
    return *this;
}


Scatterpolar & Transforms(const std::vector<CppPlotly::Trace::scatterpolar::Transform> &transforms ) {
    _scatterpolar.insert({"transforms", transforms});
    return *this;
}


/**
Assign an id to this trace, Use this to provide object constancy between traces during animations and transitions.
*/Scatterpolar & Uid(const std::string &uid ) {
    _scatterpolar.insert({"uid", uid});
    return *this;
}


/**
Controls persistence of some user-driven changes to the trace: `constraintrange` in `parcoords` traces, as well as some `editable: true` modifications such as `name` and `colorbar.title`. Defaults to `layout.uirevision`. Note that other user-driven trace attribute changes are controlled by `layout` attributes: `trace.visible` is controlled by `layout.legend.uirevision`, `selectedpoints` is controlled by `layout.selectionrevision`, and `colorbar.(x|y)` (accessible with `config: {editable: true}`) is controlled by `layout.editrevision`. Trace changes are tracked by `uid`, which only falls back on trace index if no `uid` is provided. So if your app can add/remove traces before the end of the `data` array, such that the same trace has a different index, you can still preserve user-driven changes if you give each trace a `uid` that stays with it as it moves.
*/Scatterpolar & Uirevision(const json11::Json &uirevision ) {
    _scatterpolar.insert({"uirevision", uirevision});
    return *this;
}


Scatterpolar & Unselected(const CppPlotly::Trace::scatterpolar::Unselected &unselected ) {
    _scatterpolar.insert({"unselected", unselected});
    return *this;
}


/**
Determines whether or not this trace is visible. If *legendonly*, the trace is not drawn, but can appear as a legend item (provided that the legend itself is visible).
*/Scatterpolar & Visible(const json11::Json &visible ) {
    _scatterpolar.insert({"visible", visible});
    return *this;
}


 

            virtual json11::Json to_json() const {
                return _scatterpolar;
            }

        private:
            
            json11::Json::object _scatterpolar;

        };
    }
}


