/**
 * @file Meanline.h
This attribute is part of the possible options for the trace violin.

This file has been autogenerated from the official plotly.js source.

If you like Plotly, please support them: L<https://plot.ly/> 
Open source announcement: L<https://plot.ly/javascript/open-source-announcement/>

Full reference: L<https://plot.ly/javascript/reference/#violin>

DISCLAIMER

This is an unofficial Plotly Perl module. Currently I'm not affiliated in any way with Plotly. 
But I think plotly.js is a great library and I want to use it with C++.

*/

#include <vector>
#include <string>
#include <sstream>

#include <json11.hpp>




namespace CppPlotly {
    namespace Trace {
    namespace violin {

    /**
     * 
     *
     *
     */
    class Meanline {
    public:

    /**
Sets the mean line color.
*/Meanline & Color(const json11::Json &color ) {
    _meanline.insert({"color", color});
    return *this;
}


/**
Determines if a line corresponding to the sample's mean is shown inside the violins. If `box.visible` is turned on, the mean line is drawn inside the inner box. Otherwise, the mean line is drawn from one side of the violin to other.
*/Meanline & Visible(const bool &visible ) {
    _meanline.insert({"visible", visible});
    return *this;
}


/**
Sets the mean line width.
*/Meanline & Width(const double &width ) {
    _meanline.insert({"width", width});
    return *this;
}




    json11::Json to_json() const {
        return _meanline;
    }

    private:

    json11::Json::object _meanline;

    };

    }

    }
}
